﻿Public Class Dialog

    Private Sub Dialog_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Sin.SelectedIndex = 0
        Sout.SelectedIndex = 0
    End Sub

    Private Sub SourcePower_Validating(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles SourcePower.Validating
        Dim value As Double

        Try
            value = Val(sender.Text)
        Catch ex As Exception
            MessageBox.Show("Incorrect format of number")
        End Try

        If value < -70 Then
            value = -70
        End If

        If value > 20 Then
            value = 20
        End If
        sender.Text = value.ToString()
    End Sub

    Private Sub Browse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Browse.Click
        Dim browser As System.Windows.Forms.SaveFileDialog

        browser = New System.Windows.Forms.SaveFileDialog
        If (browser.ShowDialog() = DialogResult.OK) Then
            Path.Text = browser.FileName.ToString
        End If
    End Sub

    Private Sub Generate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Generate.Click

        Dim window_name As String = "MeasSetup"
        Dim trace_name As String = "MeasTrace"
        Dim channel As Int32 = 1
        Dim window As Int32 = 1
        Dim window_trace As Int32 = 2
        Dim catalog As New System.Text.StringBuilder("", 1024)
        Dim get_dir As New System.Text.StringBuilder("", 1024)
        Dim cur_dir As New System.String("", 1024)
        Dim split As String()
        Dim i As Integer

        Cursor.Current = System.Windows.Forms.Cursors.WaitCursor

        Try
            ' Initialize the driver
            Dim instrument As New rszvl(ResourceString.Text, IDQuery.Checked, Reset.Checked)
            ' Set display update
            instrument.ConfigureDisplayUpdate(Display.Checked, False)
            ' Create new window
            instrument.ConfigureNewSetup(window_name)
            ' Retrieve the list of traces
            instrument.TraceList(channel, 1024, catalog)

            split = (catalog.ToString()).Split(",")
            For i = 0 To split.Length - 1 Step 2
                ' Delete all possibly opened traces
                instrument.TraceDelete(channel, split(i))
            Next
            ' Create a new trace
            instrument.TraceAdd(channel, trace_name)
            instrument.TraceAssignDiagramArea(window, window_trace, trace_name)
            ' Set Sweep parameters
            instrument.ConfigureSweepPoints(channel, Val(SweepNumber.Text))
            ' Set single sweep and sweep count to 1
            instrument.ConfigureAcquisition(False, 1)
            ' Set frequencies
            instrument.ConfigureFrequencyStartStop(Val(StartFreq.Text), Val(StopFreq.Text))
            ' Set Power
            instrument.ConfigureSourcePower(channel, Val(SourcePower.Text))
            ' Assign a measurement parameter to a trace
            instrument.ConfigureSParameters(channel, trace_name, Val(Sout.Text), Val(Sin.Text))
            ' Initiate measurement
            instrument.Initiate(channel, 30000)
            ' Returns the directory for mass memory storage
            instrument.GetCurrentDirectory(get_dir)
            cur_dir = get_dir.ToString()

            split = Path.Text.Split("\")

            i = 0
            While Not [Char].IsControl(cur_dir, i)
                i += 1
            End While

            cur_dir = cur_dir.Substring(0, i)
            cur_dir += "\"
            cur_dir += split(split.Length - 1)

            ' Store trace to file
            instrument.TraceExportData(trace_name, cur_dir)
            ' Copy file from instrument
            instrument.ReadToFileFromInstrument(cur_dir, Path.Text)
            ' Delete file from instrument
            instrument.FileManagerOperations(3, cur_dir, "")

        Catch ex As Exception
            Dim message As String

            message = "Instrument Status Error: "
            message += ex.Message
            MessageBox.Show(message)
        End Try

        Cursor.Current = System.Windows.Forms.Cursors.Arrow

    End Sub
End Class